# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class SuggestionsSuggestionGroup(Model):
    """SuggestionsSuggestionGroup.

    All required parameters must be populated in order to send to Azure.

    :param name: Required. Possible values include: 'Unknown', 'Web',
     'StoreApps', 'SearchHistory', 'PersonalSearchDocuments',
     'PersonalSearchTags', 'Custom'. Default value: "Unknown" .
    :type name: str or
     ~azure.cognitiveservices.search.autosuggest.models.ScenarioType
    :param search_suggestions: Required.
    :type search_suggestions:
     list[~azure.cognitiveservices.search.autosuggest.models.SearchAction]
    :param _type: Required. Constant filled by server.
    :type _type: str
    """

    _validation = {
        'name': {'required': True},
        'search_suggestions': {'required': True},
        '_type': {'required': True},
    }

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'search_suggestions': {'key': 'searchSuggestions', 'type': '[SearchAction]'},
        '_type': {'key': '_type', 'type': 'str'},
    }

    def __init__(self, *, search_suggestions, name="Unknown", **kwargs) -> None:
        super(SuggestionsSuggestionGroup, self).__init__(**kwargs)
        self.name = name
        self.search_suggestions = search_suggestions
        self._type = None
